# In this folder we get demographic data for French regions
Data downloaded from https://www.insee.fr/fr/statistiques/1893198, more precisely https://www.insee.fr/fr/statistiques/fichier/1893198/estim-pop-nreg-sexe-aq-1975-2020.xls

Saved in: estim-pop-nreg-sexe-aq-1975-2020.xls
# Then I summed the data by decade, and saved the result in estim_pop_nreg_by_decade_2020.csv

# We follow Flaxman et al., in the appendix:
Let 𝑐𝑎 be the number of infections generated in age-group a,  𝑁𝑎 the underlying size of the population in that age group and A𝑅𝑎=𝑐𝑎/𝑁𝑎 the age-group-specific attack rate. The adjusted ifris then given by:if𝑟𝑎=𝐴𝑅50−59𝐴𝑅𝑎if𝑟𝑎′, where A𝑅50−59is the predicted attack-ratein the 50-59 year age-groupafter incorporating  country-specific  patterns  of  contact  and  mixing.  

# We need the age-specific attack rate for France:


## Some analysis of XX to understand how these numbers are computed:
- CFR (proportion of all cases that will eventually die) and infection fatality ratio (IFR, the proportion of all infections that will eventually die)
- adjusting for both underlying demography and potential under-ascertainment at different levels of the severity pyramid
- 24 cases who died from COVID-19 infection in Hubei Province reported by the National Health Commission and the Hubei Province Health Commission website, which we used to estimate the onset-to-death distribution
- Time intervals between symptom onset and outcome:  Using Bayesian methods, we fitted a Gamma distributions to data on times from onset-to-death and onset-to-recovery conditional on having observed the final outcome. Missing onset dates were imputed based on dates of report where available.
- Data on 70,117 PCR-confirmed and clinically diagnosed cases by date of onset in Wuhan and elsewhere in China from 1st January to 11th February 2020 were extracted from the WHO Joint Mission Report. Over this time-period a cumulative total of 1,023 deaths were reported across China, with these data available disaggregated into ten-year age bands between 0-9 and 70-79 years old and those above 80 years old.
- Demography: Age-stratified population data for 2018 were obtained from the National Bureau of Statistics of the People’s Republic of China
- Estimates of the CFR, IFR and proportion hospitalised from aggregated case data: To estimate the CFR using aggregated data we used our estimates of the distribution of times from onset-to-death to project the expected cumulative number of deaths given the onsets observed in Wuhan and outside Wuhan. We began by assuming that the attack rate is uniform across age-groups (i.e. all ages are equally susceptible). Using the age-distribution of the population, for a given attack rate, we therefore obtained an estimate of the expected infections in each age-group. Under-ascertainment was then estimated inside and outside Wuhan by comparing observed cases by age to this expected distribution assuming perfect ascertainment in the 50-59 age-group. For Wuhan, we added an additional scaling (fitted using a Binomial likelihood) to account for further under-ascertainment compared to outside Wuhan (given the over-stretched health system). These steps gave us the expected age-distribution of cases.
- For a given onset-to-death distribution, we then obtained a modelled estimate of the cumulative deaths by age under an age-dependent CFR (fitted relative to the CFR in the oldest age-group, which represented the largest number of deaths). This was compared to the observed deaths by age using a Poisson likelihood.
- These data were then jointly fitted alongside the most-recent age-aggregated cumulative deaths and cases in mainland China, fitted using a binomial likelihood. This follows from the observation that given the current situation, where both observed cases and deaths have dropped substantially following a peak in late January, the ratio of current cumulative cases, once corrected for under-ascertainment, to current death provide a good estimate of the final CFR.
- To estimate the IFR we additionally fitted to data on infection prevalence from international Wuhan residents that were repatriated to their home countries. This is formulated as an additional Binomial likelihood, incorporating a translation from incidence to period prevalence accounting for epidemic growth over this period.

# How we get region-wide IFR?
-  We know the IFR by age in China (last column of Table 1 in Verity et al., 2020, in file IFR_China.csv). Taking as reference the age class 50-59, we know that different age classes are more or less susceptible to infections. We use this to obtain the age-specific Infection Fatality Rate: IFR_0_9=0.000016, IFR_10_19=0.00007, IFR_20_29=0.00031, etc...
-  Then, we have the country-specific CFR from Flaxman et al.. For France, it is 0.011526, whereas for China it is: 0.0138. So we can use proportionality to scale everything by 0.011526/0.0138: IFR_fr_0_9=0.000016*0.011526/0.0138, IFR_fr_10_19=0.00007*0.011526/0.0138, IFR_fr_20_29=0.00031*0.011526/0.0138, etc....
-  Then we region-wise IFRs by getting the sum of the age-class IFR_frs weighted by their population.
All of this is done in a R script computeRegionWiseIFRs.R
