suppressPackageStartupMessages({
  library(tidyverse)
  library(ggpubr)
  library(lubridate)
  library(pbapply)
  library(data.table)
  invisible(Sys.setlocale("LC_ALL", locale="en_US.utf8"))
})

pboptions(type="timer")


LOCKDOWN <- ymd("2020-03-17")
LOCKDOWN_END <- ymd("2020-05-11")

message("Loading simulated dataset")

mixture <- data.table::fread(
  file="results/simulated_datasets/mixture_lockdown_shift_explicit.csv",
  colClasses = c(date="Date", lockdown_day="Date"), showProgress = T) %>%
  filter(date <= LOCKDOWN_END) %>%
  mutate(
    model="mixture",
    sim_id = dense_rank(sample_id)
  )

sample_categories <- read_csv("results/mixture_categories.csv") %>% select(-posterior)

mixture_decoded <- sample_categories %>% inner_join(mixture) %>%
  filter(category == sampled_category)

data.table::fwrite(mixture_decoded, 
  file="results/simulated_datasets/mixture_lockdown_shift_decoded_posterior.csv")
