import os
import pandas as pd
import sys


# We want to build a table looking like:
# "reg";"dep";"sexe";"jour";"hosp";"rea";"rad";"dc"
# "01";0;"2020-03-18";2;0;1;0
# "01";1;"2020-03-18";1;0;1;0
# "01";2;"2020-03-18";1;0;0;0

# Loading useful functions
exec(open("scripts/util_fun.py").read())

# recursively builds a list "liste" of all the files in a directory "nomdir"
def explore(nomdir, liste):
        listefiles=os.listdir(nomdir)
        for i in listefiles:
                if (os.path.isdir(os.path.join(nomdir,i))):
                        explore(os.path.join(nomdir,i), liste)
                else:
                        liste.append(os.path.abspath(os.path.join(nomdir,i)))
        return()

outre_mer = ["guyane", "guadeloupe", "martinique", "wallis-et-futuna", "saint-martin", "saint-barthelemy", "reunion", "polynesie-francaise", "nouvelle-caledonie", "mayotte"]


if __name__ == '__main__':
    dir = sys.argv[1]
    outfiledep = sys.argv[2]
    outfilereg = sys.argv[3]
    outfilereg_outremer = sys.argv[4]
    outfilereg_outremer_diff = sys.argv[5]
    listeFiles = list();

    if (os.path.isdir(dir)):
        explore(dir, listeFiles)

    withDptData = 0
    withoutDptData = 0
    with open (outfiledep, "w") as out, open (outfilereg, "w") as outreg:
        out.write("\"reg\";\"dep\";\"sexe\";\"jour\";\"hosp\";\"rea\";\"rad\";\"dc\"\n")
        outreg.write("\"reg\";\"dep\";\"sexe\";\"jour\";\"hosp\";\"rea\";\"rad\";\"dc\"\n")
        for i in listeFiles:
            if "README" not in i and i.endswith(".yaml") and "_première_version" not in i:
                name_region = i.split("/")[-2]
                if name_region in outre_mer:
                    name_region = "outre-mer"
                date = i.split("/")[-1].split(".")[0]
                print (i)
                with open (i, "r") as fin:
                    rea_reg = "NA"
                    hosp_reg = "NA"
                    rad_reg = "NA"
                    dc_reg = "NA"
                    dpt = list()
                    rea = list()
                    hosp = list()
                    rad = list()
                    dc = list()
                    inRegion = False
                    inDpt= False
                    for l in fin:
                        if l.startswith("donneesRegionales"):
                            inRegion = True
                        if inRegion and l.startswith("  reanimation"):
                            rea_reg = l.split(": ")[1].split()[0]
                            print("rea_reg : " + rea_reg)
                        if inRegion and l.startswith("  hospitalise"):
                            hosp_reg = l.split(": ")[1].split()[0]
                            print("hosp_reg :"+hosp_reg)
                        if inRegion and l.startswith("  gueri"):
                            rad_reg = l.split(": ")[1].split()[0]
                            print("rad_reg :"+rad_reg)
                        if inRegion and l.startswith("  deces"):
                            dc_reg = l.split(": ")[1].split()[0]
                            print("dc_reg :"+ dc_reg)
                        if l.startswith("donneesDepartementales"):
                            inDpt = True
                        if inDpt and "code:" in l:
                            dpt.append(l.split(": ")[1].split()[0])
                            rea.append(0)
                            hosp.append(0)
                            rad.append(0)
                            dc.append(0)
                        if inDpt and l.startswith("    reanimation"):
                            rea[-1] = int(l.split(": ")[1].split()[0])
                        if inDpt and l.startswith("    hospitalises"):
                            hosp[-1] = int(l.split(": ")[1].split()[0])
                        if inDpt and l.startswith("    gueris"):
                            rad[-1] = int(l.split(": ")[1].split()[0])
                        if inDpt and l.startswith("    deces"):
                            dc[-1] = int(l.split(": ")[1].split()[0])
                    # We are done parsing the file.
                    if inDpt: # there was dpt data
                        withDptData += 1
                        # Let's check that the sums of per departments data match the per region data
                        try:
                            if rea_reg!="NA" and sum(rea) != int(rea_reg):
                                print("File "+ i + " : Department-wise reanimations do not match region-wise")
                        except ValueError as err:
                            print("Error: {0}".format(err))
                        try:
                            if hosp_reg!="NA" and sum(hosp) != int(hosp_reg):
                                print("File "+ i + " : Department-wise hospitalizations do not match region-wise")
                        except ValueError as err:
                            print("Error: {0}".format(err))
                        try:
                            if rad_reg!="NA" and sum(rad) != int(rad_reg):
                                print("File "+ i + " : Department-wise cured do not match region-wise")
                        except ValueError as err:
                            print("Error: {0}".format(err))
                        try:
                            if dc_reg!="NA" and sum(dc) != int(dc_reg):
                                print("File "+ i + " : Department-wise deaths do not match region-wise")
                        except ValueError as err:
                            print("Error: {0}".format(err))
                        for j in range(len(dpt)):
                            if str(hosp[j])=="#":
                                hosp[j] = "0"
                            if str(rea[j])=="#":
                                rea[j] = "0"
                            if str(rad[j])=="#":
                                rad[j] = "0"
                            if str(dc[j])=="#":
                                dc[j] = "0"
                            out.write(name_region + ";" + dpt[j] +";" + "O;" + date + ";" + str(hosp[j]) + ";" + str(rea[j]) + ";" + str(rad[j]) + ";" + str(dc[j]) + "\n")
                    else:
                        withoutDptData += 1
                    if inRegion : # region data
                        if hosp_reg=="#":
                            hosp_reg = "0"
                        if rea_reg=="#":
                            rea_reg = "0"
                        if rad_reg=="#":
                            rad_reg = "0"
                        if dc_reg=="#":
                            dc_reg = "0"
                        outreg.write(name_region + ";" + "NA;" + "O;" + date + ";" + hosp_reg + ";" + rea_reg + ";" + rad_reg + ";" + dc_reg + "\n")
    print("Total number of files without departmental data: " + str(withoutDptData))


    data_reg = pd.read_csv(outfilereg, sep=";", header=0, parse_dates=[3] )
    # Now we want to merge the data by region per day
    data_reg_outremer = data_reg.groupby(['reg', 'sexe', 'jour']).sum()
    data_reg_outremer.to_csv(outfilereg_outremer, sep=";")
    data_reg_outremer = pd.read_csv(outfilereg_outremer, sep=";", header=0, parse_dates=[3] )

    # Compute deltas to get numbers of events per days and not totals.
    for reg in data_reg_outremer["reg"].unique():
        calculate_change_in_field_given_value_in_other_field(df=data_reg_outremer, field_for_computing_change="dc", indicator_field="reg", indicator_value=reg, new_field="quotidien_dc")

    data_reg_outremer['dc'] = data_reg_outremer['quotidien_dc']
    del(data_reg_outremer['quotidien_dc'])
    print(data_reg_outremer.head())

    data_reg_outremer.to_csv(outfilereg_outremer_diff, sep=";", index=False)
