suppressPackageStartupMessages({
  library(tidyverse)
  library(ggpubr)
  library(lubridate)
  
  source("scripts/plots/simulations/functions.R")
})


# Commandline options and parsing
args <- commandArgs(trailingOnly = TRUE)
filename = args[1]

# ------------------------------------------------------------------------------

invisible(Sys.setlocale(locale="en_US.UTF-8"))

loaded_data <- new.env()
load(filename, envir = loaded_data)

simulated_dataset <- loaded_data$simulated_dataset
dataset <- loaded_data$dataset

figures.dir <- "figures/elections_simulation/"
dir.create(figures.dir, rec=T, showWarnings=F)

# ------------------------------------------------------------------------------

(boxp <- mortality_boxplots(simulated_dataset, dataset))

cowplot::save_plot(
  filename=file.path(figures.dir, "boxplot-elections.png"), 
  boxp,
  base_height = 4, base_asp = 2)

