import pandas as pd
import sys

def renameDpt (dep):

    print(dep)
    if dep.startswith("0"):
        toReturn = dep[1:]
        return toReturn
    else:
        return dep

if __name__ == '__main__':

    filein = sys.argv[1]
    linkRegDpt = sys.argv[2]
    outfiledep = sys.argv[3]
    outfilereg = sys.argv[4]

dpt_to_reg = dict()

with open(linkRegDpt, "r") as fin:
    for l in fin:
        li = l.split(":")
        dpt = li[1].replace("DEP-", "").strip()
        dpt_to_reg[dpt] = li[0]

# Adding the outre-mer territories:
dpt_to_reg["971"] = "outre-mer"
dpt_to_reg["972"] = "outre-mer"
dpt_to_reg["973"] = "outre-mer"
dpt_to_reg["974"] = "outre-mer"
dpt_to_reg["975"] = "outre-mer"
dpt_to_reg["976"] = "outre-mer"


with open(filein, "r") as fin, open(outfiledep, "w") as fout_dep:
    fout_dep.write("\"reg\";\"dep\";\"sexe\";\"jour\";\"hosp\";\"rea\";\"rad\";\"dc\"\n")
    for l in fin:
        if "dep" not in l:
            try:
                li = l.split(";")
                fout_dep.write(dpt_to_reg[li[0].replace("\"", "")] + ";" + li[0] + ";" + "0;" +li[1] + ";" + li[2] +";" + li[3] +";" + li[5].strip() +";" + li[4] + "\n")
            except KeyError as err:
                print("ERROR with line: " + l + "and error: {0}".format(err))


#with open(outfilereg, "w"):
data_dpt = pd.read_csv(outfiledep, sep=";", header=0 )
print(data_dpt.head())
print(data_dpt.columns)
# Now we want to merge the data by region per day
data_reg = data_dpt.groupby(['reg', 'sexe', 'jour']).sum()
data_reg.to_csv(outfilereg, sep=";")
